<template>
  <Transition name="fade">
  <div class="signup-popup" v-if="open">
    <Transition appear name="fade-up">
    <div class="signup-window" v-if="windowOpen">
      <span v-wave class="close-btn" @click="close">×</span>
      <div class="signup-title">רישום</div>
      <form class="signup-form" ref="form" autocomplete="off" @submit.prevent="signUp">
        <input class="signup-input" type="text" name="name" id="name" placeholder="שם משתמש">
        <input class="signup-input ltr" type="text" name="email" id="email" placeholder="אימייל">
        <input class="signup-input ltr" type="text" name="password" id="password" placeholder="סיסמה">
        <Transition name="grow"> 
        <div class="error" v-if="error">שגיאה!</div>
        </Transition>
        <Transition name="grow"> 
        <easy-spinner type="circular" color="rgb(170, 170, 200)" v-if="signingUp" />
        </Transition>
        <input v-wave type="submit" class="signup-btn" value="הירשם">
      </form>
    </div>
    </Transition>
  </div>
  </Transition>
</template>

<script>
import { signUp } from '../firebase.js'

export default {
  data() {
    return {
      open: false,
      windowOpen: false,
      error: false,
      signingUp: false
    }
  },
  methods: {
    signupPopup() {
      this.open = true
      this.windowOpen = true
      document.body.style.overflow = 'hidden'
    },
    signUp() {
      this.error = false
      this.signingUp = true
      let form = this.$refs.form
      let name = form.name.value
      let email = form.email.value
      let pass = form.password.value
      signUp(name, email, pass)
      .then(() => {this.close(); this.signingUp = false})
      .catch(()=> {this.error = true; this.signingUp = false})
    },
    close() {
      document.body.style.overflow = 'auto'
      this.windowOpen = false
      Promise.resolve().then(()=> {
        this.open = false
      })
    }
  }
}
</script>

<style scoped>
.signup-popup {
  position: fixed;
  z-index: 20;
  top: 0;
  height: 100vh;
  width: 100vw;
  background-color: rgba(0, 0, 90, 0.5);
  display: flex;
  align-items: center;
  justify-content: center;
}

.signup-window {
  max-width: 90%;
  padding: 1em 3em;
  overflow: auto;
  position: relative;
  font-size: 1.5em;
  background-color: #fff;
  border-radius: 1em;
  box-shadow: 0 0 1em rgba(0, 0, 90, 0.5);
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}

.signup-title {
  color: var(--blue);
  font-size: 2em;
  font-weight: bold;
  margin: .25em 0;
}
.signup-form {
  display: flex;
  flex-direction: column;
  align-items: center;
  width: 20em;
  max-width: 100%;
  font-size: 1.5em;
}

.signup-input {
  text-align: center;
  width: 100%;
  font-size: 1em;
  margin: .5em 0;
  border-radius: .25em;
  border: .1em solid var(--lightBlue);
}

.signup-btn {
  border: none;
  font-size: 1em;
  height: 2em;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  width: fit-content;
  padding: .25em .5em;
  border-radius: .25em;
  margin: .25em;
  background-color: var(--lightBlue2);
  color: #fff;
}

.error {
  color: var(--lightRed2);
  height: 1.5em;
}
</style>